// webPage.cpp - This file is meant to left as is

////////////////////////////////////////////////////////////////////////////////
//  webPage.cpp and webPage.h define the remote controll web page as a string
//      The user does not need to change this code

#include <WString.h>
#include "webPage.h"


//The html5 code:
namespace webPage {
  const String pageC = R"(

<html>
    <head>
        <title>robotwagen</title>
        
        <script> // websockets
            var websock;
            var pitch = 0;
            var roll = 0;
            var trottle = 0;
            var yaw = 0;
            function start() {
                setSensitivity();
                websock = new WebSocket('ws://' + window.location.hostname + '/ws');
                websock.onopen = function(evt) { console.log('websock open'); };
                websock.onclose = function(evt) { console.log('websock close'); start();};
                websock.onerror = function(evt) { console.log(evt); };
                websock.onmessage = function(evt) { console.log(evt);};
            }
        </script>
        
        <script> // joystick
            
            var joystick = function(parent){
                var self = this;
                this.parent = parent;
                this.status = null;
                this.jumpbackx = false;
                this.jumpbacky = false;
                this.below0x = true;
                this.below0y = true;
                this.xSensitivity = 100;
                this.ySensitivity = 100;
                this.xMax = null;
                this.yMax = null;
                
                this.getStatus = function(){ //gets status element
                    for(i = 0; i < this.parent.childNodes.length; i++){
                        item = this.parent.childNodes[i];
                        if(item.id == "statusDiv"){
                            return item;
                        }
                    }
                }
                
                this.startx = null; //startposition of finger
                this.starty = null;
                this.lasttotalx = 0;
                this.lasttotaly = 0;
                this.lastmoved = 'x';
                this.moved = false; //true if movement was more then the rejection value
                this.movedbefore = false;
                this.totalx = 0;
                this.totaly = 0;
                
                this.touchmove = function(touchobj, functionName){
                    x = parseInt(touchobj.clientX); //position of finger
                    y = parseInt(touchobj.clientY);
                    
                    distxraw = x - this.startx;//distance of startposition of finger in pixels bevore rejection
                    distyraw = this.starty - y;
                    
                    //sets moved to true if finger has been moved more than the rejection value
                    if((-distxraw>0 ? -distxraw : distxraw) > rejection || (-distyraw>0 ? -distyraw : distyraw) > rejection){
                        this.moved = true;
                    }
                    
                    distxpx = this.moved ? distxraw : 0; //distance of startposition of finger in pixels after rejection
                    distypx = this.moved ? distyraw : 0;
                    
                    distx = distxpx * (this.xSensitivity / 100); //distance of startposition of finger times the sensitivity
                    disty = distypx * (this.ySensitivity / 100);
                    
                    this.totalx = this.lasttotalx + distx; //total movement of x after letting go
                    this.totaly = this.lasttotaly + disty;
                    
                    //sets totalx or y back to zero when below it and it is not allowed to
                    if(this.below0x === false && this.totalx < 0){
                        this.totalx = 0;
                    }
                    
                    if(this.below0y === false && this.totaly < 0){
                        this.totaly = 0;
                    }
                    
                    //sets totalx or y back to max when it´s not null
                    if(this.xMax != null && this.totalx > this.xMax){
                        this.totalx = this.xMax;
                    }else if(this.xMax != null && this.totalx < -this.xMax){
                        this.totalx = -this.xMax;
                    }
                    
                    if(this.yMax != null && this.totaly > this.yMax){
                        this.totaly = this.yMax;
                    }else if(this.yMax != null && this.totaly < -this.yMax){
                        this.totaly = -this.yMax;
                    }
                    
                    //only do if the function is called by touchend
                    if(functionName == "touchend"){
                        //if the movement was more then the rejection value, lastmoved wil be x if x has been moved more, or y if y has been moved more
                        if(this.moved && (-distxpx>0 ? -distxpx : distxpx) > (-distypx>0 ? -distypx : distypx)){
                            this.lastmoved = 'x';
                        }else if(this.moved && (-distypx>0 ? -distypx : distypx) > (-distxpx>0 ? -distxpx : distxpx)){
                            this.lastmoved = 'y';
                        }
                        
                        //reset totalx or totaly if a click was detected
                        if(!this.moved){
                            if(this.jumpbackx && this.jumpbacky){      //cancel if both axies jump back
                            }else if(this.jumpbackx && !this.jumpbacky){
                                this.totaly = 0;
                            }else if(!this.jumpbackx && this.jumpbacky){
                                this.totalx = 0;
                            }else if(!this.movedbefore){
                                this.totalx = 0;
                                this.totaly = 0;
                            }else if(this.lastmoved == 'x'){
                                this.totalx = 0;
                            }else if(this.lastmoved == 'y'){
                                this.totaly = 0;
                            }
                        }
                        
                        //handle jumpbacks
                        if (this.jumpbackx) this.totalx = 0;
                        if (this.jumpbacky) this.totaly = 0;
                        
                        this.movedbefore = this.moved;
                        this.lasttotalx = this.totalx;
                        this.lasttotaly = this.totaly;
                    }
                    
                    this.status.innerHTML = 'functionName: ' + functionName + '<br>lastmoved: ' + this.lastmoved + '<br>moved: ' + this.moved + '<br> x: ' + x + 'px<br>y: ' + y + 'px<br>distx: ' + distx + '<br>disty: ' + disty + '<br>totalx: ' + this.totalx + '<br>totaly: ' + this.totaly;
                    
                }
                
                this.onstart = function(e){
                    this.moved = false; //reset moved
                    touchobj = e.targetTouches[0];
                    this.startx = parseInt(touchobj.clientX); //position of finger
                    this.starty = parseInt(touchobj.clientY);
                    this.status.innerHTML = 'functionName: touchstart<br>lastmoved: ' + this.lastmoved + '<br>moved: ' + this.moved + '<br> x: ' + this.startx + 'px<br>y: ' + this.starty + 'px';
                    e.preventDefault();
                }
                
                this.onmove = function(e){
                    this.touchmove(e.targetTouches[0], "touchmove");
                    e.preventDefault();
                }
                
                this.onend = function(e){
                    this.touchmove(e.changedTouches[0], "touchend");
                    e.preventDefault();
                }
                
                
                parent.addEventListener('touchstart', function(e){
                    self.onstart(e);
                });
                
                parent.addEventListener('touchmove', function(e){
                    self.onmove(e);
                });
                
                parent.addEventListener('touchend', function(e){
                    self.onend(e);
                });
                
                parent.addEventListener('touchcancel', function(e){
                    self.onend(e);
                });
                
                this.sendX = function(){ console.log("X: " + this.totalx) }
                this.sendY = function(){ console.log("Y: " + this.totaly) }

                return this;
            }
            </script>
            <link href="https://fonts.googleapis.com/css?family=Montserrat:800" rel="stylesheet">
    </head>
    <body style="overflow:hidden; font-size: x-large;" onload="javascript:start();">
        <div class="controlBar" style="border-style:solid; border-width:1; width:99%; height:14%; overflow:hidden; position:absolute; left:0px; top:0px;">
            <script>
                var sensitivity = 100;
                var thrustSensitivity = 100;
                function updateSensitivity(value){
                    value = parseInt(value);
                    sensitivity = value;
                    document.getElementById("sensitivitySlider").value = value;
                    document.getElementById("sensitivityForm").value = value;
                    joystickL.xSensitivity = sensitivity;
                }
                function updateThrustSensitivity(value){
                    value = parseInt(value);
                    thrustSensitivity = value;
                    document.getElementById("thrustSensitivitySlider").value = value;
                    document.getElementById("thrustSensitivityForm").value = value;
                    joystickL.ySensitivity = thrustSensitivity;
                }
                
                function setSensitivity(){
                    //set the initial sensitivity values at page load
                    updateSensitivity(sensitivity);
                    updateThrustSensitivity(thrustSensitivity);
                }
            </script>
            <label for="sensitivitySlider">Sensitivity</label>
            <input type="range" min="0" max="200" value="100" id="sensitivitySlider" step="1" oninput="updateSensitivity(value);">
            <input type="number" id="sensitivityForm" value="100" oninput="updateSensitivity(value);" style="width:50px;">
            <label for="thrustSensitivitySlider">Thrust Sensitivity</label>
            <input type="range" min="0" max="200" valTe="100" id="thrustSensitivitySlider" step="1" oninput="updateThrustSensitivity(value);">
            <input type="number" id="thrustSensitivityForm" value="100" oninput="updateThrustSensitivity(value);" style="width:50px;">
            
            <script>
                var rejection = 1; //how many pixels movement it needs before program sees it as movement
                function updateRejection(value){
                    value = parseInt(value);
                    rejection = value;
                    document.getElementById("rejectionSlider").value = value;
                    document.getElementById("rejectionForm").value = value;
                }
            </script>
            <label for="rejectionSlider">Rejection</label>
            <input type="range" min="1" max="30" value="1" id="rejectionSlider" step="1" oninput="updateRejection(value);">
            <input type="number" id="rejectionForm" value="1" oninput="updateRejection(value);" style="width:50px;">
            
            <p id="connectState"> Loading... </p>
            <script>
                setInterval(reloadConnectState,500);
                var loadingDots = 0;
                var addDots = false;
                function reloadConnectState(){
                    loadingDots = (loadingDots)%3 + 1;
                    if(websock !== undefined && websock.readyState === WebSocket.OPEN){
                        document.getElementById("connectState").innerHTML = "Connected";
                        addDots = false;
                    }else if(websock === undefined){
                         document.getElementById("connectState").innerHTML = "Loading";
                         addDots = true;
                    }else if(websock.readyState === WebSocket.CONNECTING){
                        document.getElementById("connectState").innerHTML = "Connecting";
                        addDots = true;
                    }else{
                        document.getElementById("connectState").innerHTML = "Disconnected";
                        addDots = false;
                    }
                    if(addDots === true){
                        if(loadingDots === 1){
                            document.getElementById("connectState").innerHTML += ".";
                        }else if(loadingDots === 2){
                            document.getElementById("connectState").innerHTML += "..";
                        }else if(loadingDots === 3){
                            document.getElementById("connectState").innerHTML += "...";
                        }
                    }
                }
            </script>
            
        </div>

        <button type="button" onclick="websock.send('b1') " style="width:25%;height:10%;left:0% ; top:15%;position:absolute;font-size: xx-large;background-color: #fae191;">Button 1</button>
        <button type="button" onclick="websock.send('b2') " style="width:25%;height:10%;left:25%; top:15%;position:absolute;font-size: xx-large;background-color: #ff7c7c;">Button 2</button>
        <button type="button" onclick="websock.send('b3') " style="width:25%;height:10%;right:25%;top:15%;position:absolute;font-size: xx-large;background-color: #7cff7c;">Button 3</button>
        <button type="button" onclick="websock.send('b4') " style="width:25%;height:10%;right:0% ;top:15%;position:absolute;font-size: xx-large;background-color: #7c7cff;">Button 4</button>
        
        <div class="touchbox" id="boxL" style="border-style:solid; border-width:1; width:99%; height:74%; overflow:hidden; position:absolute; left:0px; top:25%; background-color: #faca30;">
            
            <h3 id="statusDiv">Status</h3>
            <script>
                var joystickL = new joystick(document.currentScript.parentNode);
                joystickL.status = joystickL.getStatus();
                joystickL.jumpbackx = true;
                joystickL.jumpbacky = true;
                joystickL.xMax = 255;
                joystickL.yMax = 255;
                
                joystickL.xSensitivity = sensitivity;
                joystickL.ySensitivity = thrustSensitivity;

                joystickL.sendX = function(){
                    if(websock.readyState === WebSocket.OPEN){
                        websock.send("r" + String(joystickL.totalx));
                        console.log("roll:" + String(joystickL.totalx));
                    }
                }
                
                joystickL.sendY = function(){
                    if(websock.readyState === WebSocket.OPEN){
                        websock.send("t" + String(joystickL.totaly));
                        console.log("trottle:" + String(joystickL.totaly));
                    }
                }

                
                setInterval(
                  function(){
                      joystickL.sendX();
                      joystickL.sendY();
                    }, 50);

            </script>
            
            <div class="logo" id="logo" style="border-style:solid; border-width:3; border-color: #606060; border-radius: 6px; overflow:hidden; position:absolute; left:50%; margin-left: -150px; top:50%; margin-top: -30px; width:300px; height:60px; background-color: #faca30;color: #606060; text-align: center; font-family: 'Montserrat', sans-serif;font-weight:800; font-size: 50px; ">
               Junior IOT
            </div>
        </div>
    </body>
</html>
  )";

  const String pageM = R"(
<html>
    <head>
        <title>wireless monitor</title>
        <script> // websockets
            var websock;
            function start() {
                setSensitivity();
                websock = new WebSocket('ws://' + window.location.hostname + '/ws');
                websock.onopen = function(evt) { console.log('websock open'); };
                websock.onclose = function(evt) { console.log('websock close'); start();};
                websock.onerror = function(evt) { console.log(evt); };
                websock.onmessage = function(evt) { console.log(evt);};
            }
        </script>
    </head>
    <body style="overflow:hidden;" onload="javascript:start();">
      <div id="logBox" style="overflow:scroll; height:99%; width:99%;">

      </div>
    </body>
</html>

  )";
}
